
/*
 * A nice way to represent the four cardinal directions
 *
 * I'm using case classes, which you should read about in the Scala
 * documentation  
 * 
 */

sealed abstract class Direction {
  def left ():Direction
  def right ():Direction
  def opposite ():Direction
  def ordinal ():Int
}

object Direction {
 
  case object NORTH extends Direction {
    def left ():Direction = WEST
    def right ():Direction = EAST
    def opposite ():Direction = SOUTH
    def ordinal ():Int = 0
  }
  
  case object SOUTH extends Direction {
    def left ():Direction = EAST
    def right ():Direction = WEST
    def opposite ():Direction = NORTH
    def ordinal ():Int = 2
  }
  
  case object EAST extends Direction {
    def left ():Direction = NORTH
    def right ():Direction = SOUTH
    def opposite ():Direction = WEST
    def ordinal ():Int = 1
  }
  
  case object WEST extends Direction {
    def left ():Direction = SOUTH
    def right ():Direction = NORTH
    def opposite ():Direction = EAST
    def ordinal ():Int = 3
  }
}


