
/*
 * A controller for the maze game that uses a command line to get
 * commands and direct those commands to the model
 *
 * Commands:
 *  forward (or f)
 *  back    (or b)
 *  left    (or l)
 *  right   (or r)
 *  quit    (or q)
 *
 */

import java.io._

class TextController extends Controller {

  private var maze:Option[Model] = Option.none()

  def attachToModel (m:Model):Unit = 
    maze = Option.some(m);

  
  private def process (response:String):Boolean = 
    if (response=="forward" || response=="f")
      maze.valOf().performForward()
    else if (response=="back" || response=="b")
      maze.valOf().performBack()
    else if (response=="left" || response=="l")
      maze.valOf().performLeft()
    else if (response=="right" || response=="r")
      maze.valOf().performRight()
    else if (response=="quit" || response=="q") {
      System.exit(0)
      true
    }
    else 
      false


  def run ():Unit = { 

    if (maze.isNone())
      throw new Error("TextController not initialized with model");

    while (true) {
      print("> ");
      val response = readLine();
      if (!process(response))
	println("Cannot perform action");
    }
  }
}
