
/*
 * A view for the maze game that gives a textual report of what 
 * the player seens at the position of the player, in the
 * direction the player is facing
 *
 */

class TextView extends View {

  private var maze:Option[Model] = Option.none()

  def attachToModel (m:Model):Unit =
    maze = Option.some(m)

  private def status (b:Boolean):String = 
    if (b)
      "open"
    else
      "blocked"
  
  def update (vis:Visible):Unit = {
    println("Facing: " + vis.direction())
    println("Passage in front is " + status(vis.front()))
    println("Passage on left  is " + status(vis.left()))
    println("Passage on right is " + status(vis.right()))
    if (vis.frontwin())
      println("Winning square is up front")
  }

  def win ():Unit = {
    println("You won")
    System.exit(0)
  }
}
