
/*
 * The interface for the data sent by the model to the view
 * when asking for an update of the view
 *
 * This abstracts away from the details of the representation
 * of mazes, by providing a set of predicates describing which
 * openings are visible
 *
 */


trait Visible {

  def direction ():Direction

  def left ():Boolean
  def right ():Boolean
  def front ():Boolean
  def frontleft ():Boolean
  def frontright ():Boolean
  def frontfront ():Boolean
  def frontfrontleft ():Boolean
  def frontfrontright ():Boolean
  def frontfrontfront ():Boolean
  
  def frontwin ():Boolean
  def frontfrontwin ():Boolean
}
